library DLL;       {Deklarationskopf (hier LIBRARY nicht PROGRAM}
uses
  SysUtils,
  Classes;
function InPort(PortAdr:Word) : byte; stdcall;     {Funktion zum einlesen eines Bytes aus einer Hardwareadresse}

assembler; stdcall;
asm                           {Assembler beginnt}
   mov dx,portadr             {schreibe PortAdr in das Register dx}
   in al,dx                   {lese das Byte aus der Adresse, auf die das Register dx zeigt}
end;
procedure OutPort(PortAdr:Word; Databyte:Byte); stdcall;   {Procedur zur Ausgabe eines Datenbytes in eine Hardwareadresse}

assembler; stdcall;
asm                       {Assembler beginnt}
   mov al,databyte        {schreibt auszugebenes Byte in register a1}
   mov dx,portadr         {schreibe PortAdr in das Register dx}
   out dx,al              {schreibt Byte aus Regeister a1 in die Adresse, auf die dx zeigt}
end;

function ReadPort (PortAdr: Longint; Channel: Byte) : Integer; stdcall;  {Prozedur liest ein 16-Bit Wert von der DA Karte aus einem beliebigen Kanal}
var
   i,k,lowbyte,highbyte: integer;
begin
     if (Channel >= 0) and (Channel <= 15) then        {Testen ob Kanal o.k.}
        Begin
          outport (PortAdr,Channel);                   {Hardware mitteilen welcher Kanal gelesen werden soll}
          outport (PortAdr+3,0);                       {Hardware initialisieren}
          for i := 0 to 6 do
          begin
                outport (PortAdr+4,0);
                for k := 1 to 10000 do; {Warteschleife}
          end;

          for i := 0 to 6 do
          begin
                outport (PortAdr+5,0);
                for k := 1 to 10000 do; {Warteschleife}

          end;
          lowbyte := (inport (PortAdr+1));                   {lese lowbyte}
          highbyte := inport (PortAdr+2);                     {lese highbyte}

          ReadPort := (highbyte- (highbyte div 16)*16)*256 +lowbyte;      {Subere highbyte und berechne 16-bit Wert}
          end
        else
        readPort := 9999  {Wenn Channel falsch, dann gebe 9999 zurck}

end;


      exports
          OutPort index 1,         {Sagt dem Compiler, das er diese Proceduren inder DLL zugnglich machen soll}
          InPort index 2,
          ReadPort index 3;
begin
end.
